<html>
<head>
    <title>Mine Block</title>
	<style>
	table, td{
		border-collapse: collapse;
		border: 1px solid;
	}
	</style>
	<script src="head.js"></script>
	<script>
	let walIdx = 0;
	let cluster = 0;
	let role = 0;
	let timeStart = 0;
	
	async function loadJson(role, walIdx){	//disIdx
		let rsp01 = await fetch('http://35.161.83.70:' + role + '/operator/wallets/') ;
		let jR01 = await rsp01.json();
		console.log(jR01);
		
		
		let txTable = "<table>";
		txTable += "<tr><td>Role</td><td>http://35.161.83.70:<select id='roleSel' onchange='loadJson(this.value, 0)'>";
		for(let i = 0; i < 3; i++){
			txTable += "<option value='" + (cluster*1+i) + "'>" + (cluster*1+i) + "</option>";
		}
		txTable += "</select></td></tr>";
		
		// Select a Wallet
		txTable += "<tr><td>Wallet</td><td><select id='walletSel' onchange='loadJson(" + role + ",this.value)'>";
		jR01.forEach(function(wallet, index){
			txTable += "<option value='" + index + "'>" + wallet.id + "</option>";
		})
		txTable += "</select></td></tr>";
		
		// Select a Reward Address
		txTable += "<tr><td>Reward Address</td><td><select id='rwdAddrSel'>";
		jR01[walIdx].addresses.forEach(function(addr, index){
			txTable += "<option value='" + addr + "'>" + addr + "</option>";
		})
		txTable += "</select></td></tr>";
		
		// Select a Fee Address
		txTable += "<tr><td>Fee Address</td><td><select id='feeAddrSel'>";
		jR01[walIdx].addresses.forEach(function(addr, index){
			txTable += "<option value='" + addr + "'>" + addr + "</option>";
		})
		txTable += "</select></td></tr>";
		
		// Submit Button
		txTable += "<tr><td>Mine</td><td><button onclick='postData(" + role + ", \"" + jR01[walIdx].id + "\")'>Mine a Block</button><span id='submitResult'></span><span id='timeUsed'></span><span id='blockInfo'></span></td></tr></table>";
		
		document.getElementById("mineDiv").innerHTML = txTable;
		
		//dropdown pre-select the current info
		document.getElementById("walletSel").getElementsByTagName('option')[walIdx].selected = "selected";
		document.getElementById("roleSel").getElementsByTagName('option')[role - cluster].selected = "selected";
	}
	//loadJson(role, walIdx);
	
	//function to set post request
	async function postData(role, walId) {
		// Default options are marked with *
		timeStart = Date.now();
		document.getElementById("submitResult").innerHTML = "&emsp;<img src='https://c.tenor.com/I6kN-6X7nhAAAAAj/loading-buffering.gif' height='30'/>";
		const response = await fetch('http://35.161.83.70:' + role + '/miner/mine/', {
			method: 'POST', // *GET, POST, PUT, DELETE, etc.
			//mode: 'cors', // no-cors, *cors, same-origin
			cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
			//credentials: 'same-origin', // include, *same-origin, omit
			headers: {
				'Content-Type': 'application/json'
				//'walletId': walId,
				//'Password': document.getElementById('pw').value
				// 'Content-Type': 'application/x-www-form-urlencoded',
			},
			redirect: 'follow', // manual, *follow, error
			referrerPolicy: 'no-referrer', // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
			body: JSON.stringify({
				  "rewardAddress": document.getElementById('rwdAddrSel').value,
				  "feeAddress": document.getElementById('feeAddrSel').value
				}) // body data type must match "Content-Type" header
		});
		console.log(response);
		document.getElementById("submitResult").innerHTML = "<br> Block : " + response.statusText + "";
		document.getElementById("timeUsed").innerHTML = "<br> Time elapsed : " + (Date.now() - timeStart)/1000 + "s";
		let responseJson = await response.json();
		console.log(responseJson);
		
		showMinedBlock(responseJson);
		
		
		/*
		let responseJson = await response.json();
		console.log(responseJson);
		let txID = responseJson.id ;
		let checkTxIdConfirmationLink = 'http://35.161.83.70:' + role + "/node/transactions/" + txID + "/confirmations" ;
		let linkDisplayString = "<a href='" +checkTxIdConfirmationLink+ "' target='_blank'>" + txID + "</a>" ;
		*/
		//return response.json(); // parses JSON response into native JavaScript objects
	}
	
	function showMinedBlock(blockInfo){
		// show the block after mining
		let blockSpan = "<br> Block Index: " + blockInfo.index;
		blockSpan += "<br>Block Hash: " + blockInfo.hash
		
		document.getElementById("blockInfo").innerHTML = blockSpan;
		
		
		let blockTable = "<table><tr>";
		blockTable += "<tr><td>Index</td><td>" + blockInfo.index + "</td></tr>";
		let date = new Date(blockInfo.timestamp * 1000);
		blockTable += "<tr><td>Timestamp</td><td>" + blockInfo.timestamp + "&emsp;[" + date + "]</td></tr>";
		blockTable += "<tr><td>Prev Hash</td><td>" + blockInfo.previousHash + "</td></tr>";
		blockTable += "<tr><td>Current Hash</td><td>" + blockInfo.hash + "</td></tr>";
		blockTable += "<tr><td>Nonce</td><td>" + blockInfo.nonce + "</td></tr>";
		blockTable += "<tr><td>Total Transactions</td><td>" + blockInfo.transactions.length;
		
		/*blockTable += "<tr><td>Merkle Root</td><td>(Merkle Root)</td></tr>";
		blockTable += "<tr><td>Difficulty</td><td>(Difficulty)</td></tr>";
		blockTable += "<tr><td>Transactions</td><td>(Table of transactions)";
		blockInfo.transactions.forEach(function(disBlkTx, index){
			blockTable += "<table><tr><td>index</td><td>" + index + "</td></tr>";
			blockTable += "<tr><td>id</td><td>" + disBlkTx.id + "</td></tr>";
			blockTable += "<tr><td>hash</td><td>" + disBlkTx.hash + "</td></tr>";
			blockTable += "<tr><td>type</td><td>" + disBlkTx.type + "</td></tr>";
			blockTable += "<tr><td>data</td><td>";
				blockTable += "<table><tr><td>Inputs</td><td>";
				if(disBlkTx.data.inputs != ""){
					disBlkTx.data.inputs.forEach(function(disInputTx, index, array){
						blockTable += "<table><tr><td>Tx id</td><td>" + disInputTx.transaction + "</td></tr>";
						blockTable += "<tr><td>Index</td><td>" + disInputTx.index + "</td></tr>";
						blockTable += "<tr><td>Amount</td><td>" + disInputTx.amount + "</td></tr>";
						blockTable += "<tr><td>Address</td><td>" + disInputTx.address + "</td></tr>";
						blockTable += "<tr><td>Signature</td><td>" + disInputTx.signature + "</td></tr></table>";
					});
				} else{
					blockTable += "null";
				}
				blockTable += "<tr><td>Outputs</td><td>";
				disBlkTx.data.outputs.forEach(function(disOutputTx, index, array){
					blockTable += "<table><tr><td>Amount</td><td>" + disOutputTx.amount + "</td></tr>";
					blockTable += "<tr><td>Address</td><td>" + disOutputTx.address + "</td></tr></table>";
				});
				blockTable += "</table>";
			blockTable += "</td></tr>";
			blockTable += "";
		});
		*/
		blockTable += "</td></tr></table>";
		
		document.getElementById("showBlock").innerHTML = blockTable;
		
	}
	
	</script>
</head>
<body onload="printPageHeader()">
	<div id="jsHeader">
		Mine Block
	</div>
	
	<br>
	<div id="mineDiv">
		table showing here...
	</div>
	<br>
	<div id="showBlock">
	</div>
	
	<br><!--
	<h3>
    	Miner Mining Block Manually?
    </h3>
	<table id="blocks">
	<tr><td>Next Index</td><td>(next index)</td></tr>
	<tr><td>Timestamp</td><td>(Timestamp)</td></tr>
	<tr><td>Prev Hash</td><td>(previousHash)</td></tr>
	<tr><td>Difficulty</td><td>(Difficulty)</td></tr>
	<tr><td>Nonce</td><td><input type="text" id="nonce" value="0"></td></tr>
	<tr><td>Transactions</td><td>
		(Transactions to be selected for mining)<br>
		<select>
			<option value="0">- -Select- -</option>
			<option value="1">(txid pool 1)</option>
			<option value="2">(txid pool 2)</option>
		</select><br>
		<select>
			<option value="0">- -Select- -</option>
			<option value="1">(txid pool 1)</option>
			<option value="2">(txid pool 2)</option>
		</select>
	</td></tr>
	<tr><td>Mine</td><td><input type="button" value="Try to Mine a Block"></td></tr>
	<tr><td>Block Hash</td><td>(CurrentHash after calculation)</td></tr>
	<tr><td>Valid Hash</td><td>(Check if smaller than target value)<br><input type="button" value="Publish (You can see me when this is mine is valid"></td></tr>
	</table>-->
</body>
</html>